using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_Aplicacion.Modelos_MantenimientoAgrupacionesCabecera;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_HotelPuntoVenta.General;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_HotelPuntoVenta._1_Datos
{
    public class HPV_AgrupacionesPLVLineas_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo> g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_AUX = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_AgrupacionesPLVLineas).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo != null) && (g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Count() > 0))
                {
                    lst_AUX = g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_AUX;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_AUX = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_AgrupacionesPLVLineas).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo != null) && (g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Count() > 0))
                {
                    dnm_AUX = g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_AUX;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                //Filtros de Opciones ..............................................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";

                long lng_Padre_id_AgrupacionCabecera = -1;
                string str_Padre_Opcion_AgrupacionCabecera = "";

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //AGRUPACION CABECERA
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(Variables.G_STR_OPCION_HPV_AGRUPACIONESPLVCABECERAS))
                        {
                            lng_Padre_id_AgrupacionCabecera = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Padre_Opcion_AgrupacionCabecera = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                        else
                        {
                            lng_Padre_id = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Padre_Opcion = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                    }
                }
                //...................................................................

                string str_SQL =
                  " SELECT DISTINCT " +
                          nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.id) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.id) + "," +
                          nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.codigo) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.codigo) + "," +
                          nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.descripcion) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.descripcion) + "," +
                          nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.fechaBorrado) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + "," +
                          //ids
                          nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.idAgrupacionCabecera) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + "," +
                          //AgrupacionCabecera
                          nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cabecera_Codigo) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.codigo) + "," +
                          nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cabecera_Descripcion) + " =" + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.descripcion) + "," +
                          nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cabecera_FechaBorrado) + " =" + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) +
                       " FROM " + nameof(HPV_AgrupacionesPLVLineas) +
                       //AgrupacionCabecera
                       " LEFT JOIN " + nameof(HPV_AgrupacionesPLVCabeceras) + " ON " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + " = " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.id) +
                       " WHERE " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + " IS NULL AND " +
                                      //Agrupacion cabecera
                                      (
                                           (lng_Padre_id_AgrupacionCabecera > -1)
                                           ? (nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + "=@lng_Padre_id_AgrupacionPLVCabecera")
                                           : ("1 = 1")
                                      )
                                      + " AND (" +
                                             nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idEmpresa) + "=@idEmpresa" +
                                            (
                                                (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                                    ? (" OR " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                                    : " "
                                            ) +
                                      " ) AND " +
                                      (
                                         (_lng_id > -1)
                                         ? (nameof(HPV_AgrupacionesPLVLineas) + "." + (nameof(HPV_AgrupacionesPLVLineas.id) + "=@id"))
                                         : ("1 = 1")
                                      )
                                      + " AND " +
                                      nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.fechaBorrado) + " IS NULL ";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@lng_Padre_id", lng_Padre_id));
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));
                lst_Parametros.Add(new SqlParameter("@lng_Padre_id_AgrupacionPLVCabecera", lng_Padre_id_AgrupacionCabecera));


                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }

        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_AUX = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_AgrupacionesPLVLineas).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3 != null)
                {
                    dnm_AUX = g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_AUX;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_AUX = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Conuslta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_AgrupacionesPLVLineas).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3 != null)
                {
                    dnm_AUX = g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_AUX;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionas);

                //Filtros de Opciones ..............................................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";

                long lng_Padre_id_AgrupacionCabecera = -1;
                string str_Padre_Opcion_AgrupacionCabecera = "";

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //AGRUPACION CABECERA
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(Variables.G_STR_OPCION_HPV_AGRUPACIONESPLVCABECERAS))
                        {
                            lng_Padre_id_AgrupacionCabecera = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Padre_Opcion_AgrupacionCabecera = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                        else
                        {
                            lng_Padre_id = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                            str_Padre_Opcion = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                        }
                    }
                }
                //...................................................................

                string str_SQL =
                  " SELECT distinct " +
                      nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.id) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.id) + "," +
                      nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.codigo) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.codigo) + "," +
                      nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.descripcion) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.descripcion) + "," +
                      nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.fechaBorrado) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) +
              " FROM " + nameof(HPV_AgrupacionesPLVLineas) +
              " LEFT JOIN " + nameof(HPV_AgrupacionesPLVCabeceras) + " ON " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + " = " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.id) +
              " WHERE " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + " IS null AND " +
                           nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.fechaBorrado) + " IS null AND " +
                            //Agrupacion articulo cabecera
                            (
                                (lng_Padre_id_AgrupacionCabecera > -1)
                                ? (nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + "=@lng_Padre_id_AgrupacionPLVCabecera")
                                : ("1 = 1")
                            )
                            + " AND " +
                          " ( " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idEmpresa) + "=@idEmpresa" +
                                (
                                    (_lst_idEmpresasRelacionas != null && _lst_idEmpresasRelacionas.Count > 0)
                                        ? (" OR " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                        : " "
                                ) +
                          " ) AND " +
                            (
                                (_lng_id > -1)
                                    ? (nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.id) + " = " + _lng_id)
                                    : (
                                        //Filtrar por Codigo
                                        (_str_CampoBusqueda.Equals(nameof(HPV_AgrupacionesPLVLineas.codigo)))
                                            ? (nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.codigo) + "=@Filtro")
                                            //Filtrar por Descripcion
                                            : (nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.descripcion) + "=@Filtro")
                                    )
                            );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@lng_Padre_id", lng_Padre_id));
                lst_Parametros.Add(new SqlParameter("@lng_Padre_id_AgrupacionPLVCabecera", lng_Padre_id_AgrupacionCabecera));
                lst_Parametros.Add(new SqlParameter("@Filtro", _str_Filtro));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_mdl_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 3;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                " SELECT distinct " +
                    nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.id) + " = " + nameof(HPV_AgrupacionesPLVLineas.id) + "," +
                    nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.codigo) + " = " + nameof(HPV_AgrupacionesPLVLineas.codigo) + "," +
                    nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.descripcion) + " = " + nameof(HPV_AgrupacionesPLVLineas.descripcion) + "," +
                    nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.idAgrupacionCabecera) + " = " + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + "," +
                    nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.idEmpresa) + " = " + nameof(HPV_AgrupacionesPLVLineas.idEmpresa) + "," +
                    nameof(INTERNO_MantenimientoAgrupacionesLinea_Modelo.fechaBorrado) + " = " + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) +
                " FROM " + nameof(HPV_AgrupacionesPLVLineas) +
                " WHERE " + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + " IS null AND " +
                            nameof(HPV_AgrupacionesPLVLineas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoAgrupacionesLinea_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //HPV_PLV_AgrupacionesPLVLineas ##########################################################################################
                    ThreadStart obj_ThreadStart_PROVEEDOR_AGRUPACIONESPLVLINEAS = new ThreadStart(Obtener_PLV_AgrupacionesPLVLineas_Modelo_Obtener);
                    Thread obj_Thread_PROVEEDOR_AGRUPACIONESPLVLINEAS = new Thread(obj_ThreadStart_PROVEEDOR_AGRUPACIONESPLVLINEAS);
                    obj_Thread_PROVEEDOR_AGRUPACIONESPLVLINEAS.Start();

                    //HPV_AgrupacionesPLVLineasFotos ##########################################################################################
                    ThreadStart obj_ThreadStart_AGRUPACIONESPLVLINEASFOTOS = new ThreadStart(Obtener_AgrupacionesPLVLineas_Fotos_Modelo_Obtener);
                    Thread obj_Thread_AGRUPACIONESPLVLINEASFOTOS = new Thread(obj_ThreadStart_AGRUPACIONESPLVLINEASFOTOS);
                    obj_Thread_AGRUPACIONESPLVLINEASFOTOS.Start();

                    //HPV_AgrupacionesPLVLineas_Impresoras ##########################################################################################
                    ThreadStart obj_ThreadStart_AGRUPACIONESPLVLINEASIMPRESORAS = new ThreadStart(Obtener_AgrupacionesPLVLineas_Impresoras_Modelo_Obtener);
                    Thread obj_Thread_AGRUPACIONESPLVLINEASIMPRESORAS = new Thread(obj_ThreadStart_AGRUPACIONESPLVLINEASIMPRESORAS);
                    obj_Thread_AGRUPACIONESPLVLINEASIMPRESORAS.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_PLV_AgrupacionesPLVLineas_Modelo_Obtener()
        {
            try
            {
                HPV_PLV_AgrupacionesPLVLineas_Datos obj_HPV_PLV_AgrupacionesPLVLineas_Datos = new HPV_PLV_AgrupacionesPLVLineas_Datos();
                g_dnm_Modelo_Obtener.Listado_Agrupados = obj_HPV_PLV_AgrupacionesPLVLineas_Datos.Obtener_Listado_idPLV_PorIdAgrupacionPLVLinea(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_AgrupacionesPLVLineas_Fotos_Modelo_Obtener()
        {
            try
            {
                HPV_AgrupacionesPLVLineasFotos_Datos obj_HPV_AgrupacionesPLVLineasFotos_Datos = new HPV_AgrupacionesPLVLineasFotos_Datos();
                g_dnm_Modelo_Obtener.Imagen_Modelo = obj_HPV_AgrupacionesPLVLineasFotos_Datos.Obtener_FotoModelo_Por_IdAgrupacionPLVLinea(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        private void Obtener_AgrupacionesPLVLineas_Impresoras_Modelo_Obtener()
        {
            try
            {
                HPV_AgrupacionesPLVLineas_Impresoras_Datos obj_HPV_AgrupacionesPLVLineas_Impresoras_Datos = new HPV_AgrupacionesPLVLineas_Impresoras_Datos();
                g_dnm_Modelo_Obtener.Listado_Impresoras = obj_HPV_AgrupacionesPLVLineas_Impresoras_Datos.Obtener_Listado_idImpresora_PoridAGrupacionArticuloLinea(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public List<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo> Obtener_HPV_AgrupacionesPLVLineas_PorCabecera(long _lng_idAgrupacionPLVCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo> lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
              " SELECT " +
                  nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.id) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.id) + "," +
                  nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.codigo) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.codigo) + "," +
                  nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.descripcion) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.descripcion) + "," +
                  nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cabecera_Codigo) + "= CASE WHEN ( NOT " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + " IS NULL ) THEN " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.codigo) + " ELSE convert(varchar,'') END, " +
                  nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.Cabecera_Descripcion) + "= CASE WHEN ( NOT " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + " IS NULL ) THEN " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.descripcion) + " ELSE convert(varchar,'') END, " +
                  nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.fechaBorrado) + "= CASE WHEN ( NOT " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + " IS NULL ) THEN " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.fechaBorrado) + " ELSE NULL END, " +
                  nameof(INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo.orden) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.orden) +
              " FROM " + nameof(HPV_AgrupacionesPLVLineas) +
              " LEFT JOIN " + nameof(HPV_AgrupacionesPLVCabeceras) + " ON " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + "=" + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.id) +
              " WHERE " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + " IS null AND " +
                          nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + "=@idAgrupacionPLVCabecera ";
                //.......................................................................................

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idAgrupacionPLVCabecera",  _lng_idAgrupacionPLVCabecera)
                };

                //Rellenar el Modelo
                lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener_HPV_AgrupacionesPLVLineas_PorCabecera), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_INTERNO_MantenimientoAgrupacionesLineas_Listado_Modelo;
        }

        public List<INTERNO_IDCodigoDescripcion_Modelo> Existen_Repetidos(List<long> _lst_idsAgrupacionesLineas_Actuales, long _lng_idAgrupacionLineaActual, List<long> _lst_idPLV)
        {
            List<INTERNO_IDCodigoDescripcion_Modelo> lst_PLVs_Repetidos = new List<INTERNO_IDCodigoDescripcion_Modelo>();
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtro_PLV = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idPLV);
                string str_Filtro_AgrupacionLinea = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idsAgrupacionesLineas_Actuales);

                string str_SQL =
                     " SELECT " +
                         nameof(INTERNO_IDCodigoDescripcion_Modelo.Id) + " = " + nameof(HPV_PLV) + "." + nameof(HPV_PLV.id) + "," +
                         nameof(INTERNO_IDCodigoDescripcion_Modelo.Codigo) + " = " + nameof(HPV_PLV) + "." + nameof(HPV_PLV.codigo) + "," +
                         nameof(INTERNO_IDCodigoDescripcion_Modelo.Descripcion) + " = " + nameof(HPV_PLV) + "." + nameof(HPV_PLV.descripcion) +
                     " FROM " + nameof(HPV_PLV_AgrupacionesPLVLineas) +
                     " LEFT JOIN " + nameof(HPV_AgrupacionesPLVLineas) + " ON " + nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idAgrupacionPLVLinea) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.id) +
                     " LEFT JOIN " + nameof(HPV_PLV) + " ON " + nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idPLV) + " = " + nameof(HPV_PLV) + "." + nameof(HPV_PLV.id) +
                     " WHERE " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + " IS null " +
                               (
                                   (_lst_idPLV != null && _lst_idPLV.Count > 0)
                                       ? (" AND " + nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idPLV) + " in (" + str_Filtro_PLV + ") ")
                                       : " "
                               ) +
                             " AND NOT " + nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idAgrupacionPLVLinea) + "=@idAgrupacionPLVLinea " +
                               (
                                   (_lst_idsAgrupacionesLineas_Actuales != null && _lst_idsAgrupacionesLineas_Actuales.Count > 0)
                                       ? (" AND " + nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idAgrupacionPLVLinea) + " in (" + str_Filtro_AgrupacionLinea + ") ")
                                       : " "
                               );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idAgrupacionPLVLinea", _lng_idAgrupacionLineaActual));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                lst_PLVs_Repetidos = obj_Exferia_Entities.Database.SqlQuery<INTERNO_IDCodigoDescripcion_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Existen_Repetidos), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_PLVs_Repetidos;
        }

        public List<long> Obtener_RegistroRepetidos(List<long> _lst_idsAgrupacionesLineas_Actuales, long _lng_idAgrupacionLineaActual)
        {
            List<long> lst_Repetidos = new List<long>();
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtro_AgrupacionLinea = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idsAgrupacionesLineas_Actuales);

                string str_SQL =
                  " SELECT " +
                      nameof(HPV_PLV) + "." + nameof(HPV_PLV.id) +
                  " FROM " + nameof(HPV_PLV_AgrupacionesPLVLineas) +
                  " LEFT JOIN " + nameof(HPV_AgrupacionesPLVLineas) + " ON " + nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idAgrupacionPLVLinea) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.id) +
                  " LEFT JOIN " + nameof(HPV_PLV) + " ON " + nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idPLV) + " = " + nameof(HPV_PLV) + "." + nameof(HPV_PLV.id) +
                  " WHERE " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + " IS null " +
                            (
                                (_lst_idsAgrupacionesLineas_Actuales != null && _lst_idsAgrupacionesLineas_Actuales.Count > 0)
                                    ? (" AND " + nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idAgrupacionPLVLinea) + " in (" + str_Filtro_AgrupacionLinea + ") ")
                                    : " "
                            ) +
                          " AND ( NOT " + nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idAgrupacionPLVLinea) + "=@idAgrupacionPLVLinea ) ";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idAgrupacionPLVLinea", _lng_idAgrupacionLineaActual));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                lst_Repetidos = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener_RegistroRepetidos), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_Repetidos;
        }

        public List<long> Obtener_PorPLV(long _lng_idPLV, long _lng_idEmpresa, Exferia_Entities _obj_Exferia_Entities)
        {
            List<long> lst_Lineas_Por_PLV = new List<long>();

            try
            {
                //Empresas relacionadas
                List<long> lst_idEmpresasrelacionadas = Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresa, typeof(HPV_AgrupacionesPLVLineas).Name);
                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idEmpresasrelacionadas);

                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_SQL =
                   " SELECT DISTINCT " +
                       nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idAgrupacionPLVLinea) +
                   " FROM " + nameof(HPV_PLV_AgrupacionesPLVLineas) +
                   " LEFT JOIN " + nameof(HPV_AgrupacionesPLVLineas) + " ON " + nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idAgrupacionPLVLinea) + " = " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.id) +
                   " LEFT JOIN " + nameof(HPV_AgrupacionesPLVCabeceras) + " ON " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + " = " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.id) +
                   " WHERE " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.fechaBorrado) + " IS null AND " +
                               nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + " IS null AND " +
                               nameof(HPV_PLV_AgrupacionesPLVLineas) + "." + nameof(HPV_PLV_AgrupacionesPLVLineas.idPLV) + "=@idPLV AND" +
                           " ( " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.idEmpresa) + "=@idEmpresa" +
                               (
                                   (lst_idEmpresasrelacionadas != null && lst_idEmpresasrelacionadas.Count > 0)
                                       ? (" OR " + nameof(HPV_AgrupacionesPLVCabeceras) + "." + nameof(HPV_AgrupacionesPLVCabeceras.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                       : " "
                               ) +
                           " )";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idPLV", _lng_idPLV));
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresa));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                lst_Lineas_Por_PLV = _obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener_PorPLV), true);
            }

            return lst_Lineas_Por_PLV;
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private HPV_AgrupacionesPLVLineas g_mdl_HPV_AgrupacionesPLVLineas = null;
        public HPV_AgrupacionesPLVLineas Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(HPV_AgrupacionesPLVLineas) + "." + nameof(HPV_AgrupacionesPLVLineas.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_HPV_AgrupacionesPLVLineas;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                           object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_HPV_AgrupacionesPLVLineas = obj_Exferia_Entities.Database.SqlQuery<HPV_AgrupacionesPLVLineas>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<HPV_AgrupacionesPLVLineas> g_lst_HPV_AgrupacionesPLVLineas = null;

        public List<HPV_AgrupacionesPLVLineas> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids,
                                                                                   bool _bol_Cargar_AgrupacionesArticulosCabeceras)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(HPV_AgrupacionesPLVLineas),
                                                                                                    nameof(HPV_AgrupacionesPLVLineas.id),
                                                                                                    G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                                    _lst_Ids);

                    string str_SQL = Obtener_Consulta_Modelo() +
                                        //WHERE
                                        " WHERE " + str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { },
                                                     _bol_Cargar_AgrupacionesArticulosCabeceras);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_HPV_AgrupacionesPLVLineas;
        }

        #region Ejecutar Consulta
        //Listado de modelos Relacionados
        private List<HPV_AgrupacionesPLVCabeceras> g_lst_HPV_AgrupacionesPLVCabeceras = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros,
                                                    bool _bol_Cargar_AgrupacionesArticulosCabeceras)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_HPV_AgrupacionesPLVLineas = obj_Exferia_Entities.Database.SqlQuery<HPV_AgrupacionesPLVLineas>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_HPV_AgrupacionesPLVLineas != null && g_lst_HPV_AgrupacionesPLVLineas.Count > 0)
                {
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_AgrupacionesArticulosCabeceras)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //MAE_AgrupacionesArticulosCabeceras #############################################
                        if (_bol_Cargar_AgrupacionesArticulosCabeceras)
                        {
                            ThreadStart obj_ThreadStart_AGRUPACIONARTICULOCABECERA = new ThreadStart(Obtener_AgrupacionArticuloCabecera_Modelo_Listado);
                            Thread obj_Thread_AGRUPACIONARTICULOCABECERA = new Thread(obj_ThreadStart_AGRUPACIONARTICULOCABECERA);
                            obj_Thread_AGRUPACIONARTICULOCABECERA.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (HPV_AgrupacionesPLVLineas mdl_HPV_AgrupacionesPLVLineas in g_lst_HPV_AgrupacionesPLVLineas)
                        {
                            //MAE_AgrupacionesArticulosCabeceras #############################################
                            if (_bol_Cargar_AgrupacionesArticulosCabeceras &&
                               g_lst_HPV_AgrupacionesPLVCabeceras != null &&
                               g_lst_HPV_AgrupacionesPLVCabeceras.Count > 0)
                            {
                                mdl_HPV_AgrupacionesPLVLineas.HPV_AgrupacionesPLVCabeceras = g_lst_HPV_AgrupacionesPLVCabeceras.Where(m => m.id == mdl_HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera).FirstOrDefault();
                            }
                        }
                        #endregion
                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas relacionadas
        private void Obtener_AgrupacionArticuloCabecera_Modelo_Listado()
        {
            try
            {
                HPV_AgrupacionesPLVCabeceras_Datos obj_HPV_AgrupacionesPLVCabeceras_Datos = new HPV_AgrupacionesPLVCabeceras_Datos();
                g_lst_HPV_AgrupacionesPLVCabeceras = obj_HPV_AgrupacionesPLVCabeceras_Datos.Obtener_ModeloListado_Por_Ids(g_lst_HPV_AgrupacionesPLVLineas.Select(m => m.idAgrupacionPLVCabecera).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        #endregion

        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(HPV_AgrupacionesPLVLineas.id) + " , " +
                   nameof(HPV_AgrupacionesPLVLineas.codigo) + " , " +
                   nameof(HPV_AgrupacionesPLVLineas.descripcion) + " , " +
                   nameof(HPV_AgrupacionesPLVLineas.colorFondo) + " , " +
                   nameof(HPV_AgrupacionesPLVLineas.colorLetra) + " , " +
                   nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + " , " +
                   nameof(HPV_AgrupacionesPLVLineas.idEmpresa) + " , " +
                   nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + " , " +
                   nameof(HPV_AgrupacionesPLVLineas.orden) +
               " FROM " + nameof(HPV_AgrupacionesPLVLineas);
        }

        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                //dbcontext.Configuration.LazyLoadingEnabled = false;

                INTERNO_MantenimientoAgrupacionesLinea_Modelo mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar = (INTERNO_MantenimientoAgrupacionesLinea_Modelo)_mdl_obj;

                //PLV relacionados
                List<long> lst_ids_PLV = mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar.Listado_Agrupados.ToList();
                HPV_AgrupacionesPLVLineas mdl_HPV_AgrupacionesPLVLineas_DatosViejos = new HPV_AgrupacionesPLVLineas();

                // Ver si existe ######################################################################
                HPV_AgrupacionesPLVLineas mdl_HPV_AgrupacionesPLVLineas_Final = Obtener_Modelo_Por_Id(mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_HPV_AgrupacionesPLVLineas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_HPV_AgrupacionesPLVLineas_Final, mdl_HPV_AgrupacionesPLVLineas_DatosViejos, false, false);

                    //Copio las propiedades sin relaciones
                    Cargar_DatosModelo(mdl_HPV_AgrupacionesPLVLineas_Final, mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar);

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(HPV_AgrupacionesPLVLineas) +
                                          " SET " +
                                              nameof(HPV_AgrupacionesPLVLineas.codigo) + "=@codigo," +
                                              nameof(HPV_AgrupacionesPLVLineas.descripcion) + "=@descripcion," +
                                              nameof(HPV_AgrupacionesPLVLineas.colorFondo) + "=@colorFondo," +
                                              nameof(HPV_AgrupacionesPLVLineas.colorLetra) + "=@colorLetra," +
                                              nameof(HPV_AgrupacionesPLVLineas.idEmpresa) + "=@idEmpresa," +
                                              nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + "=@idAgrupacionPLVCabecera," +
                                              nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + "=@fechaBorrado," +
                                              nameof(HPV_AgrupacionesPLVLineas.orden) + "=@orden " +
                                          " WHERE " +
                                              nameof(HPV_AgrupacionesPLVLineas.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_HPV_AgrupacionesPLVLineas_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_HPV_AgrupacionesPLVLineas_Final.descripcion),
                        mdl_HPV_AgrupacionesPLVLineas_Final.colorFondo!=null
                            ?   new SqlParameter("@colorFondo", mdl_HPV_AgrupacionesPLVLineas_Final.colorFondo)
                            :   new SqlParameter("@colorFondo",  DBNull.Value),
                        mdl_HPV_AgrupacionesPLVLineas_Final.colorLetra!=null
                            ?   new SqlParameter("@colorLetra", mdl_HPV_AgrupacionesPLVLineas_Final.colorLetra)
                            :   new SqlParameter("@colorLetra",  DBNull.Value),
                        new SqlParameter("@idAgrupacionPLVCabecera",  mdl_HPV_AgrupacionesPLVLineas_Final.idAgrupacionPLVCabecera),
                        new SqlParameter("@idEmpresa",  mdl_HPV_AgrupacionesPLVLineas_Final.idEmpresa),
                        mdl_HPV_AgrupacionesPLVLineas_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_HPV_AgrupacionesPLVLineas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         mdl_HPV_AgrupacionesPLVLineas_Final.orden!=null
                            ?   new SqlParameter("@orden", mdl_HPV_AgrupacionesPLVLineas_Final.orden.Value)
                            :   new SqlParameter("@orden",  DBNull.Value),
                        new SqlParameter("@id",  mdl_HPV_AgrupacionesPLVLineas_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_HPV_AgrupacionesPLVLineas_Final = new HPV_AgrupacionesPLVLineas();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_HPV_AgrupacionesPLVLineas_Final, mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo_AGrabar);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(HPV_AgrupacionesPLVLineas) +
                                               " (" +
                                                       nameof(HPV_AgrupacionesPLVLineas.codigo) + "," +
                                                       nameof(HPV_AgrupacionesPLVLineas.descripcion) + "," +
                                                       nameof(HPV_AgrupacionesPLVLineas.colorFondo) + "," +
                                                       nameof(HPV_AgrupacionesPLVLineas.colorLetra) + "," +
                                                       nameof(HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera) + "," +
                                                       nameof(HPV_AgrupacionesPLVLineas.idEmpresa) + "," +
                                                       nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + "," +
                                                       nameof(HPV_AgrupacionesPLVLineas.orden) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(MAE_TiposGastos.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@codigo," +
                                                   "@descripcion," +
                                                   "@colorFondo," +
                                                   "@colorLetra," +
                                                   "@idAgrupacionPLVCabecera," +
                                                   "@idEmpresa," +
                                                   "@fechaBorrado," +
                                                   "@orden" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_HPV_AgrupacionesPLVLineas_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_HPV_AgrupacionesPLVLineas_Final.descripcion),
                        mdl_HPV_AgrupacionesPLVLineas_Final.colorFondo!=null
                            ?   new SqlParameter("@colorFondo", mdl_HPV_AgrupacionesPLVLineas_Final.colorFondo)
                            :   new SqlParameter("@colorFondo",  DBNull.Value),
                        mdl_HPV_AgrupacionesPLVLineas_Final.colorLetra!=null
                            ?   new SqlParameter("@colorLetra", mdl_HPV_AgrupacionesPLVLineas_Final.colorLetra)
                            :   new SqlParameter("@colorLetra",  DBNull.Value),
                        new SqlParameter("@idAgrupacionPLVCabecera",  mdl_HPV_AgrupacionesPLVLineas_Final.idAgrupacionPLVCabecera),
                        new SqlParameter("@idEmpresa",  mdl_HPV_AgrupacionesPLVLineas_Final.idEmpresa),
                        mdl_HPV_AgrupacionesPLVLineas_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_HPV_AgrupacionesPLVLineas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         mdl_HPV_AgrupacionesPLVLineas_Final.orden!=null
                            ?   new SqlParameter("@orden", mdl_HPV_AgrupacionesPLVLineas_Final.orden.Value)
                            :   new SqlParameter("@orden",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }


                //Borrar Relaciones Antiguas ..............................................
                string str_SQL_Borrar = " DELETE FROM " + nameof(HPV_PLV_AgrupacionesPLVLineas) + " WHERE " + nameof(HPV_PLV_AgrupacionesPLVLineas.idAgrupacionPLVLinea) + "=" + mdl_HPV_AgrupacionesPLVLineas_Final.id;
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Borrar);
                //.........................................................................

                //Grabar Relaciones Nuevas .................................................
                if (lst_ids_PLV != null & lst_ids_PLV.Count > 0)
                {
                    string str_SQL_Insertar = "";
                    foreach (long lng_id in lst_ids_PLV)
                    {
                        str_SQL_Insertar += " INSERT INTO " + nameof(HPV_PLV_AgrupacionesPLVLineas) + " (" + nameof(HPV_PLV_AgrupacionesPLVLineas.idPLV) + "," + nameof(HPV_PLV_AgrupacionesPLVLineas.idAgrupacionPLVLinea) + "," + nameof(HPV_PLV_AgrupacionesPLVLineas.observaciones) + ") values (" + lng_id + "," + mdl_ValorDevuelto_Modelo.Id + ",'')";
                    }

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Insertar);
                }
                //.........................................................................

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_AgrupacionesPLVLineas), mdl_HPV_AgrupacionesPLVLineas_DatosViejos, mdl_HPV_AgrupacionesPLVLineas_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        private void Cargar_DatosModelo(HPV_AgrupacionesPLVLineas _mdl_HPV_AgrupacionesPLVLineas, INTERNO_MantenimientoAgrupacionesLinea_Modelo _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo)
        {
            // Cargar los Datos Nuevos del Modelo
            _mdl_HPV_AgrupacionesPLVLineas.id = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.id;
            _mdl_HPV_AgrupacionesPLVLineas.codigo = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.codigo;
            _mdl_HPV_AgrupacionesPLVLineas.descripcion = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.descripcion;
            _mdl_HPV_AgrupacionesPLVLineas.orden = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.orden;
            _mdl_HPV_AgrupacionesPLVLineas.idEmpresa = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.idEmpresa;
            _mdl_HPV_AgrupacionesPLVLineas.colorFondo = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.colorFondo;
            _mdl_HPV_AgrupacionesPLVLineas.colorLetra = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.colorLetra;
            _mdl_HPV_AgrupacionesPLVLineas.idAgrupacionPLVCabecera = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.idAgrupacionCabecera;
            _mdl_HPV_AgrupacionesPLVLineas.fechaBorrado = _mdl_INTERNO_MantenimientoAgrupacionesLinea_Modelo.fechaBorrado;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;
           
            try
            {

                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                HPV_AgrupacionesPLVLineas mdl_HPV_AgrupacionesPLVLineas_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_HPV_AgrupacionesPLVLineas_Final != null)
                {
                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(HPV_AgrupacionesPLVLineas) +
                                                " SET " +
                                                nameof(HPV_AgrupacionesPLVLineas.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(HPV_AgrupacionesPLVLineas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_AgrupacionesPLVLineas), null, mdl_HPV_AgrupacionesPLVLineas_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }
                    
                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idAgrupacionesLineas = (List<long>)_mdl_obj;

                if (lst_idAgrupacionesLineas != null & lst_idAgrupacionesLineas.Count > 0)
                {
                    //Coger los ids y ponerlos de forma que sirva para la consulta
                    string str_Filtros_IDs = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idAgrupacionesLineas);

                    string str_SQL = " DELETE FROM " + nameof(HPV_AgrupacionesPLVLineas) +
                                     " WHERE " + nameof(HPV_AgrupacionesPLVLineas.id) + " in (" + str_Filtros_IDs + ")";

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

    }
}
